#! /usr/bin/python3

import os, os.path
import sqlite3
from datetime import datetime

class Messages:
    def __init__(self, jolla=os.getenv("HOME")):
        dbfile = os.path.join(jolla, ".local/share/commhistory/commhistory.db")
        self._db = sqlite3.connect(dbfile)
    
    def list(self, number=None):
        cursor = self._db.cursor()
        
        query = """
SELECT startTime, direction, remoteUid, freeText
FROM Events
WHERE type = '2'
        """
        
        if number is None:
            results = cursor.execute(query)
        else:
            query  += "AND remoteUid LIKE ?"
            results = cursor.execute(query, ["%" + number + "%"])
        
        for (startTime, direction, remoteUid, freeText) in results:
            c = {}
            c["startTime"] = datetime.fromtimestamp(startTime)
            c["freeText"]  = freeText
            c["remoteUid"] = remoteUid
            if direction == 2:
                c["direction"] = "out"
            elif direction == 1:
                c["direction"] = "in"
            else:
                raise Exception("Invalid direction", direction)
            
            yield c

